## diet 2.8.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)
project(DIET)

set(DIET_MAJOR_VERSION 2)
set(DIET_MINOR_VERSION 8)
set(DIET_REVISION_VERSION 0)

set(DIET_VERSION
  "${DIET_MAJOR_VERSION}.${DIET_MINOR_VERSION}.${DIET_REVISION_VERSION}")

add_definitions(-DDIET_VERSION="${DIET_VERSION}")

# Get Date
if (WIN32)
  execute_process(COMMAND "date" "+%Y/%m/%d-%H:%M:%S" 
    OUTPUT_VARIABLE BUILD_DATE)
  string(STRIP ${BUILD_DATE} BUILD_DATE) # get rid of newline
elseif (UNIX)
  execute_process(COMMAND "date" "+%Y/%m/%d-%H:%M:%S" 
    OUTPUT_VARIABLE BUILD_DATE)
  string(STRIP ${BUILD_DATE} BUILD_DATE) # get rid of newline
else (WIN32)
  message(SEND_ERROR "date not implemented")
  set(${BUILD_DATE} 000000)
endif (WIN32)

set(DIET_BUILD_VERSION ${BUILD_DATE})

# because x86_64 can't link static libraries to shared libraries
# and from 2.5, this is what is done in DIET
# see http://www.mail-archive.com/cross-lfs%40linuxfromscratch.org/msg00411.html
# You will get these messages on x86_64 any place that libtool tries to use a static (.a) library in a .la, and as it says, it can't link. These "recompile with -fPIC" messages fall into three types - 
# (i) recompile the current package with -fPIC
# (ii) fix a broken symlink (I had a dangling symlink for ncurses in my scripts, because of a typo - on x86 libtool couldn't find the .so but took the .a and ran with it, on x86_64 it barfed). 
# (iii) convert a Makefile to use .la instead of .a (very uncommon).

# Note: CMAKE_SYSTEM_PROCESSOR return the equivalent of uname -p, note uname -m

if (UNIX AND NOT WIN32)
  find_program(CMAKE_UNAME uname /bin /usr/bin /usr/local/bin )
  if (CMAKE_UNAME)
    exec_program(uname ARGS -m OUTPUT_VARIABLE SYSTEM_PROC_TYPE)
    set(SYSTEM_PROC_TYPE ${SYSTEM_PROC_TYPE} CACHE INTERNAL 
    	"processor type (i386 and x86_64)")
    if (SYSTEM_PROC_TYPE MATCHES "x86_64|amd64")
      # TODO: Should be done only for libraries build
      add_definitions(-fPIC)
    endif()
  endif()
endif()


# --------------------- OPTIONS OF THE PROJECT -----------------------------
# Options dependencies:
#    - DIET_BUILD_BLAS_EXAMPLES => DIET_BUILD_EXAMPLES
#    - DIET_USE_CLOUD => DIET_USE_ALT_BATCH

option(DIET_BUILD_BLAS_EXAMPLES "Build BLAS based DIET examples." OFF)
if (DIET_BUILD_BLAS_EXAMPLES)
  if (NOT DIET_BUILD_EXAMPLES)
    set(DIET_BUILD_EXAMPLES ON CACHE BOOL "Build DIET examples." FORCE)
    message(WARNING "Examples building was activated.")
  endif (NOT DIET_BUILD_EXAMPLES)
  option(DIET_BUILD_EXAMPLES "Build DIET examples. (Mandatory for BLAS examples building.)" ON)
  
else (DIET_BUILD_BLAS_EXAMPLES)
  option(DIET_BUILD_EXAMPLES      "Build DIET examples." OFF)
endif (DIET_BUILD_BLAS_EXAMPLES)

option(DIET_USE_CLOUD "Build DIET with Cloud (EC2 compatible) support." OFF)

if (DIET_USE_CLOUD)
  if (NOT DIET_USE_ALT_BATCH)
  	set(DIET_USE_ALT_BATCH ON CACHE BOOL "Batch support" FORCE)
    message(WARNING "Batch was activated for cloud support.")
	endif (NOT DIET_USE_ALT_BATCH)
	option(DIET_USE_ALT_BATCH "Build DIET with Batch support (Mandatory for cloud support)." ON)
else (DIET_USE_CLOUD)
	option(DIET_USE_ALT_BATCH  "Build DIET with Batch support." OFF)
endif (DIET_USE_CLOUD)

option(DIET_USE_WORKFLOW    "Build DIET with workflow support..." OFF)
option(DIET_WITH_STATISTICS "Build DIET with generation of statistics." OFF)
option(DIET_WITH_MULTI_MA   "Build DIET with MULTI-Master-Agent support." OFF)
option(DIET_USE_USERSCHED   "Build DIET with user scheduler support (Experimental)." OFF)
option(DIET_USE_CCS         "Build DIET with client custom scheduling  (Experimental)." OFF)
option(DIET_BUILD_TOOLS	    "Build DIET tools." OFF)

option( DIET_USE_MULTICALL "Build DIET with the multiple async call (In development)" OFF)
mark_as_advanced(DIET_USE_MULTICALL)

option(DIET_BUILD_DOC "Build DIET documentation." OFF)

# --------------------- OPTIONS SET BY DEFAULT  ----------------------------
# Are libraries dynamic libraries as opposed to library archives ?
# Note: this variable is a cmake internal, hence not prefixed with DIET_.
option(BUILD_SHARED_LIBS "Build libraries as shared libraries." ON)

# --------------------- DEPENDENCIES TOWARDS "CLASSIC" C++ HEADERS ---------
# This is just a convenience to advance the detection of any potential missing
# C++ "classic" header to the cmake stage. If we were to forget the following
# tests (and such a header was missing), things would simply break at
# preprocessing stage of the compilation...
# [Those tests are a translation of the AC_CHECK_HEADER(...) that were expressed
# in the configure.ac of the autotools version].
include(${CMAKE_ROOT}/Modules/CheckIncludeFileCXX.cmake)

set(DIET_INCLUDES_TO_CHECK
  assert.h
  iostream
  limits.h
  math.h
  stdlib.h
  string.h
  unistd.h
  sys/stat.h
  sys/types.h
)

foreach (include_to_check ${DIET_INCLUDES_TO_CHECK})
  CHECK_INCLUDE_FILE_CXX( ${include_to_check} dummyfound${include_to_check} )
  if (NOT dummyfound${include_to_check})
    message(FATAL_ERROR "Missing ${include_to_check} header file.")
  endif (NOT dummyfound${include_to_check})
endforeach (include_to_check)

# --------------------- DEPENDENCIES TOWARDS SYSTEM FUNCTIONS ------------
# This is just a convenience to advance the detection of any potential missing
# external function to the cmake stage. If we were to forget the following
# tests (and such an external function was missing), things would simply break
# at linking stage...
# [Those tests are a translation of the AC_CHECK_FUNCS(...) that were expressed
# in the configure.ac of the autotools version].
INCLUDE(${CMAKE_ROOT}/Modules/CheckFunctionExists.cmake)

set(DIET_FUNCTIONS_TO_CHECK
  gethostname
  gettimeofday
  strdup
  strtok_r
)

foreach(function_to_check ${DIET_FUNCTIONS_TO_CHECK})
  CHECK_FUNCTION_EXISTS( ${function_to_check} dummyfound${function_to_check} )
  if (NOT dummyfound${function_to_check})
    message(FATAL_ERROR "Missing ${function_to_check} function.")
  endif (NOT dummyfound${function_to_check})
endforeach (function_to_check)

#-------------- PLATFORM SPECIFIC COMPILATION FLAGS -----------------------
# Requires CMake >= 2.4.7
# Used within omniORB, when set remove some warnings/errors
# Not tested under SunOS & FreeBSD

string(COMPARE EQUAL ${CMAKE_SYSTEM_NAME} "AIX" AIX)
string(COMPARE EQUAL ${CMAKE_SYSTEM_NAME} "Darwin" APPLE)
string(COMPARE EQUAL ${CMAKE_SYSTEM_NAME} "Linux" LINUX)
string(COMPARE EQUAL ${CMAKE_SYSTEM_NAME} "SunOS" SUNOS)
string(COMPARE EQUAL ${CMAKE_SYSTEM_NAME} "FreeBSD" FREEBSD)
string(COMPARE EQUAL ${CMAKE_SYSTEM_NAME} "CYGWIN" CYGWIN)

if (CYGWIN)
  add_definitions(-D__cygwin__)

  # Workflow compilation on Windows inside the Cygwin environment
  # is not permitted until the good compilation of the libraries of
  # XQilla and Xerces are available.
  # For instance it is not possible so we have to wait for the 
  # problem resolution
  # TODO : solve the problem.
  set(DIET_USE_WORKFLOW OFF CACHE BOOL "Unable to compile workflow on Windows with Cygwin. " FORCE)

elseif (AIX)
  add_definitions(-D__aix__)
elseif (APPLE)
  add_definitions( -D__darwin__)
  if (NOT BUILD_SHARED_LIBS)
    message("Cannot do a static build on Apple platforms")
  endif (NOT BUILD_SHARED_LIBS)

  set(BUILD_SHARED_LIBS ON CACHE BOOL "Build libraries as shared libraries." FORCE)
elseif (LINUX)
  add_definitions(-D__linux__)
elseif (SUNOS)
  add_definitions(-D__sunos__)
elseif(FREEBSD)
  add_definitions(-D__freebsd__)
endif (CYGWIN)

# --------------------- DEPENDENCIES TOWARDS EXTERNAL PACKAGES -------------
# Path to additional modules (i.e. used by FIND_PACKAGE commands making
# reference to non CMake defined "standard" modules):
set(CMAKE_MODULE_PATH ${DIET_SOURCE_DIR}/Cmake)

# Boost is mandatory
find_package(Boost 1.46.0 COMPONENTS regex REQUIRED)
if(Boost_FOUND)
  set(THIRD_PARTY_LIBS ${THIRD_PARTY_LIBS} ${Boost_LIBRARIES})
endif()

# OmniORB is mandatory:
find_package(OmniORB)
if (OMNIORB4_FOUND)
  add_definitions(-D__OMNIORB4__)
	if (BUILD_SHARED_LIBS)
	  # Link DIET to OmniORB shared libs
		set(OMNIORB4_LIBRARIES ${OMNIORB4_LIBRARIES_sh})
	else (BUILD_SHARED_LIBS)
	  # Link DIET to OmniORB static libs
		set(OMNIORB4_LIBRARIES ${OMNIORB4_LIBRARIES_st})
	endif (BUILD_SHARED_LIBS)
   set(THIRD_PARTY_LIBS ${THIRD_PARTY_LIBS} ${OMNIORB4_LIBRARIES})
else (OMNIORB4_FOUND)
  message("omniORB installation was not found. Please provide OMNIORB4_DIR:")
  message("  - through the GUI when working with ccmake, ")
  message("  - as a command line argument when working with cmake e.g. ")
  message("    cmake .. -DOMNIORB4_DIR:PATH=/usr/local/omniORB-4.0.7 ")
  message("Note: the following message is triggered by cmake on the first ")
  message("    undefined necessary PATH variable (e.g.  OMNIORB4_INCLUDE_DIR).")
  message("    Providing OMNIORB4_DIR (as above described) is probably the")
  message("    simplest solution unless you have a really customized/odd")
  message("    omniORB installation...")
  set(OMNIORB4_DIR "" CACHE PATH "Root of omniORB install tree.")
endif (OMNIORB4_FOUND)

# --------------------------- Batch support ------------------------
if (DIET_USE_ALT_BATCH)
    add_definitions(-DHAVE_ALT_BATCH)
endif (DIET_USE_ALT_BATCH)

# --------------------------- Cloud support ------------------------
if (DIET_USE_CLOUD)
    add_definitions(-DHAVE_CLOUD)
    set(GSOAP_SRC_DIR "~" CACHE PATH "Root of gSOAP source tree.")
endif (DIET_USE_CLOUD)

# --------------------------- CORI support ------------------------
# CORI (COllector of Resource Information) is heavily dependant on
# system calls for probing ressources:
include(${DIET_SOURCE_DIR}/Cmake/ConfigureCORI.cmake)

# --------------------------- Multi MA support ------------------------
# So called MULTI-Master-Agent
if (DIET_WITH_MULTI_MA)
  add_definitions(-DHAVE_MULTI_MA)
endif (DIET_WITH_MULTI_MA)

# --------------------------- Statistic support ------------------------
if (DIET_WITH_STATISTICS)
  # Enable generation of the statistics log:
  add_definitions( -DHAVE_STATISTICS )
endif (DIET_WITH_STATISTICS)

if (DIET_BUILD_BLAS_EXAMPLES)
  # BLAS (Basic Linear Algebric Subroutines) examples subdir requires...BLAS !
  find_package(BLAS)
  IF (BUILD_SHARED_LIBS)
    SET(BLAS_LIBRARIES ${BLAS_LIBRARIES_sh})
  ELSE (BUILD_SHARED_LIBS)
    SET(BLAS_LIBRARIES ${BLAS_LIBRARIES_st})
  ENDIF (BUILD_SHARED_LIBS)
endif (DIET_BUILD_BLAS_EXAMPLES)

# --------------------------- Workflow support ------------------------
if (DIET_USE_WORKFLOW)
  find_package(Xerces)
  if (XERCES_FOUND)
    if (XERCES_VERSION LESS 30)
      message("Diet Workflow support requires at least version 3.0 of Xerces.")
      message("Workflow support will be disabled")
      set(DIET_USE_WORKFLOW OFF)
    else (XERCES_VERSION LESS 30)
      find_package(XQilla)
      if (XQILLA_FOUND)
        add_definitions(-DHAVE_WORKFLOW)
	if (BUILD_SHARED_LIBS)
	  # Link DIET to Xerces and XQilla shared libs
	  set(XERCES_LIBRARY ${XERCES_LIBRARY_sh})
	  set(XQILLA_LIBRARY ${XQILLA_LIBRARY_sh})
	else (BUILD_SHARED_LIBS)
	  # Link DIET to Xerces and XQilla static libs
	  set(XERCES_LIBRARY ${XERCES_LIBRARY_st})
	  set(XQILLA_LIBRARY ${XQILLA_LIBRARY_st})
	endif (BUILD_SHARED_LIBS)
        set(THIRD_PARTY_LIBS ${THIRD_PARTY_LIBS}
          ${XERCES_LIBRARY}
          ${XQILLA_LIBRARY})
      else (XQILLA_FOUND)
        message("Diet Workflow support requires XQilla library." )
        message("Workflow support will be disabled")
        set(DIET_USE_WORKFLOW OFF)
      endif (XQILLA_FOUND)
    endif(XERCES_VERSION LESS 30)
  else (XERCES_FOUND)
    set(DIET_USE_WORKFLOW OFF
         CACHE BOOL "Build DIET with workflow support...")
  endif (XERCES_FOUND)
endif (DIET_USE_WORKFLOW)

# --------------- For users agents scheduler support ------------------
if (DIET_USE_USERSCHED)
  add_definitions(-DUSERSCHED)
endif(DIET_USE_USERSCHED)

# --------------- Dagda as data manager support ---------------
if (DIET_TRANSFER_PROGRESSION)
  add_definitions(-DDAGDA_PROGRESSION)

=== Cmake/CMakeLists.txt ===
### Build the configuration file for external projects using DIET and cmake:
configure_file( DietConfig.cmake.in
  ${CMAKE_CURRENT_BINARY_DIR}/DietConfig.cmake
  @ONLY )
# install in CMake module path
install( FILES ${CMAKE_CURRENT_BINARY_DIR}/DietConfig.cmake DESTINATION ${CMAKE_MOD_INSTALL_DIR} )

### Build the configuration file for external projects using DIET and make:
get_directory_property( COMPILE_FLAGS DEFINITIONS )
configure_file( ${CMAKE_CURRENT_SOURCE_DIR}/Makefile.inc.in
  ${CMAKE_BINARY_DIR}/include/Makefile.inc
  IMMEDIATE )
install( FILES ${CMAKE_BINARY_DIR}/include/Makefile.inc DESTINATION ${INCLUDE_INSTALL_DIR} )

# ADD_SUBDIRECTORY( Ctest )

# install FindDiet.cmake in CMake module path
install( FILES FindDiet.cmake DESTINATION ${CMAKE_MOD_INSTALL_DIR} )

=== doc/CMakeLists.txt ===
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/Cmake)

# set documentation install dir
set(DOC_INSTALL_DIR "share/doc/${PROJECT_NAME}"
  CACHE PATH "Directory where doc will be installed")

# set man pages install dir
set(MAN_INSTALL_DIR "share/man"
  CACHE PATH "Directory where man pages will be installed")
# create doc target if non-existant
add_custom_target(doc ALL)

# cleanup
set_property(DIRECTORY APPEND PROPERTY
  ADDITIONAL_MAKE_CLEAN_FILES doc)

##############################################################################
# Options
##############################################################################
option(DIET_BUILD_USERMANUAL "Build DIET User Manual." ON)
option(DIET_BUILD_USERFAQ "Build DIET User FAQ." ON)
option(DIET_BUILD_PROGRAMMERGUIDE "Build DIET Programmer Guide." OFF)
mark_as_advanced(DIET_BUILD_PROGRAMMERGUIDE)
option(DIET_BUILD_MANPAGE "Build DIET Manpages." ON)
option(DIET_BUILD_DOXYGEN "Build DIET Doxygen." OFF)

##############################################################################
# Doxygen is required for building API doc
# no Doxygen, no API doc
#
##############################################################################
if(DIET_BUILD_DOXYGEN)
  include(UseDoxygen)
  generate_doxygen(FORMATS ${DOXYGEN_FORMATS})
endif()


#############################################################################
# Guides require latex, transfig and ImageMagick to be installed
#
#############################################################################
find_package(LATEX)
find_package(Transfig)
find_package(ImageMagick)

set(ENABLE_GUIDE ON)
if(NOT PDFLATEX_COMPILER)
  message(WARNING " Latex installation was not found.")
  set(ENABLE_GUIDE OFF)
endif()

if(NOT TRANSFIG_FOUND)
  message(WARNING " Transfig installation was not found. Please provide FIG2DEV.")
  set(ENABLE_GUIDE OFF)
endif()

if(NOT IMAGEMAGICK_CONVERT_EXECUTABLE)
  message("Convert ImageMagick utility was not found.")
  message("Please provide IMAGEMAGICK_CONVERT_EXECUTABLE.")
  set(ENABLE_GUIDE OFF)
endif()

if(ENABLE_GUIDE)
  include(Cmake/UseLATEX.cmake)
  if(DIET_BUILD_PROGRAMMERGUIDE)
    add_subdirectory(ProgrammersGuide)
  endif()

  if(DIET_BUILD_USERMANUAL)
    # UsersManual correctly built but cmake may raise an error
    # due to latex number of warnings
    add_subdirectory(UsersManual)
  endif()

  if(DIET_BUILD_USERFAQ)
    add_subdirectory(UsersFAQ)
  endif()
else()
  message(WARNING " Guides will not be built due to missing requirements.")
endif()


#############################################################################
# man pages generation
# we need rst2man for the generation
#
#############################################################################
if(DIET_BUILD_MANPAGE)
  find_program(RST2MAN_BIN rst2man)
  if(RST2MAN_BIN)
    add_subdirectory(man)
  else()
    message(WARNING " Man pages will not be built due to missing requirements.")
    message(WARNING " Please install rst2man (usually included in python-docutils package)")
  endif()
endif()

=== include/CMakeLists.txt ===
#
# DIET cmake local file
#

INSTALL( FILES
    DIET_client.h
    DIET_data.h
    DIET_mutex.h
    DIET_grpc.h
    DIET_server.h
    grpc.h
    DIET_admin.h

    DESTINATION
    ${INCLUDE_INSTALL_DIR}
)

=== src/CMakeLists.txt ===
#****************************************************************************#
#* DIET cmake local file                                                    *#
#****************************************************************************#

# This macro extracts the complete path to the generated header file
# containing the name passed as arg2 and stores it into arg1.
macro(corba_header arg1 arg2)
  foreach(hdr ${IDL_GENERATED_HEADERS})
    string(REGEX MATCH ".*/${arg2}.hh" result ${hdr})
    if (NOT ${result} EQUAL "")
      set(${arg1} ${result})
    endif (NOT ${result} EQUAL "")
  endforeach(hdr)
endmacro(corba_header)

# This macro extracts the complete paths to the generated header files
# containing the names passed as arguments and stores them into arg1
macro(corba_headers arg1)
  foreach (arg ${ARGV})
    corba_header(tmp ${arg})
    set(res ${res} ${tmp})
  endforeach(arg)
  set(${arg1} ${res})
endmacro(corba_headers)

include_directories(${Boost_INCLUDE_DIRS})

add_subdirectory(CORBA/idl)

add_subdirectory(utils)
add_subdirectory(CORBA)
add_subdirectory(utils/nodes)
add_subdirectory(client)
if (DIET_USE_WORKFLOW)
  add_subdirectory(utils/workflow)
endif (DIET_USE_WORKFLOW)

add_subdirectory(agent)
add_subdirectory(SeD)
add_subdirectory(Testing)

if( DIET_BUILD_EXAMPLES )
  add_subdirectory( examples )
endif( DIET_BUILD_EXAMPLES )

=== doc/ExternalExample/CMakeLists.txt ===
PROJECT( DIETSIMPLEEXAMPLE )

cmake_minimum_required(VERSION 2.6)

# This example needs the FindDiet.cmake package detection script. We placed
# this script in the Cmake sub-directory:
SET( CMAKE_MODULE_PATH ${DIETSIMPLEEXAMPLE_SOURCE_DIR}/Cmake )

# Try to automaticaly detect a DIET installation...
FIND_PACKAGE( Diet )

# ...and on failure provide the user with some hints:
IF( NOT DIET_FOUND )
  IF( DIET_DIR ) 
    MESSAGE( "The provided DIET_DIR parameter seems NOT correct." )
  ELSE( DIET_DIR ) 
    MESSAGE("Could NOT find any DIET installation among the well known paths.")
    MESSAGE("If your DIET installation is in a non canonical place, please provide DIET_DIR:")
    MESSAGE("  - through the GUI when working with ccmake, ")
    MESSAGE("  - as a command line argument when working with cmake e.g. ")
    MESSAGE("    cmake .. -DDIET_DIR:PATH=/home/<your_login_name>/local/diet ")
  ENDIF( DIET_DIR ) 
ENDIF( NOT DIET_FOUND )

# On success use the information we just recovered: 
INCLUDE_DIRECTORIES( ${DIET_INCLUDE_DIR} )
LINK_DIRECTORIES( ${DIET_LIBRARY_DIR} )

### Define a simple server...
ADD_EXECUTABLE( simple_server simple_server.c )
TARGET_LINK_LIBRARIES( simple_server ${DIET_SERVER_LIBRARIES} )
INSTALL( TARGETS simple_server DESTINATION bin )

### ... and it's associated simple client.
ADD_EXECUTABLE( simple_client simple_client.c )
TARGET_LINK_LIBRARIES( simple_client ${DIET_CLIENT_LIBRARIES} )
INSTALL( TARGETS simple_client DESTINATION bin )

=== doc/ExternalExample/Makefile ===
# The following inclusion provides convenient make variables for compiling
# and linking against the DIET library (DIET_HOME is an environment variable
# containing the path to a DIET installation directory):
include ${DIET_HOME}/include/Makefile.inc

all: simple_client simple_server

simple_client: simple_client.c $(DIET_CLIENT_PREREQ)
	$(CXX) -g $(CXXFLAGS_DIET) $< $(DIET_CLIENT_LIBS) -o $@
simple_server: simple_server.c  $(DIET_SERVER_PREREQ)
	$(CC) -g $(CCFLAGS_DIET) $< $(DIET_SERVER_LIBS) -o $@
clean: 
	rm -f simple_client simple_server

=== doc/UsersFAQ/CMakeLists.txt ===
set( LATEX_OUTPUT_PATH ${CMAKE_CURRENT_BINARY_DIR})

add_latex_document( UsersFAQ.tex
  IMAGE_DIRS fig
  IMAGES
  fig/logo_DIET_big.png
  fig/logo_DIET.png
  MANGLE_TARGET_NAMES
  DEFAULT_PDF )

add_dependencies( doc UsersFAQ_pdf )

install( FILES ${CMAKE_CURRENT_BINARY_DIR}/UsersFAQ.pdf
  DESTINATION ${DOC_INSTALL_DIR} )

## FIXME: if you want to compile the doc on windaube
#if( WIN32 )
#  exec_program( mkdir ARGS ${CMAKE_CURRENT_BINARY_DIR}/Data )
#  exec_program( cp ARGS ${DIET_DOC_SOURCE_DIR}/../src/examples/Batch/client.c ${CMAKE_CURRENT_BINARY_DIR}/Data/examples_Batch_client.c )
#  exec_program( cp ARGS ${DIET_DOC_SOURCE_DIR}/../src/examples/Batch/batch_server.c ${CMAKE_CURRENT_BINARY_DIR}/Data/examples_Batch_batch_server.c )
#  exec_program( cp ARGS ${DIET_DOC_SOURCE_DIR}/../src/examples/Batch/sequential_server.c ${CMAKE_CURRENT_BINARY_DIR}/Data/examples_Batch_sequential_server.c )
#endif()

=== doc/UsersManual/CMakeLists.txt ===
set( LATEX_OUTPUT_PATH ${CMAKE_CURRENT_BINARY_DIR})

add_latex_document(UsersManual.tex
  INPUTS description.tex
  install.tex
  data.tex
  client.tex
  server.tex
  batch.tex
  cloud.tex
  plugin.tex
  forwarder.tex
  prediction.tex
  deploy.tex
  dashboard.tex
  multima.tex
  workflow.tex
  xml_example.tex
  agent_scheduler.tex
  dagda.tex
  client_scheduler.tex
  dynamic.tex
  appendix.tex
  BIBFILES UsersManual.bib
  IMAGE_DIRS fig
  IMAGES fig/DIET_arch_request-2.pdf
  fig/VizDIET.pdf
  fig/VizDIET_screenshot_2.png
  fig/data.fig
  fig/global_platform.fig
  fig/init.fig
  fig/logo_DIET_big.png
  fig/multima.fig
  fig/overviewCori.fig
  fig/smprod.fig
  fig/wf_example1.fig
  fig/wf_archi2.fig
  fig/wf_archi1.fig
  fig/DiagrammeGridRPCDietStructure.fig
  fig/logo_DIET.png
  fig/DIETScheduling.pdf
  fig/schdl00.pdf
  fig/schdl01.pdf
  fig/schdl02.pdf
  fig/schdl03.pdf
  fig/schdl04.pdf
  fig/schdl05.pdf
  fig/dagdaArch.pdf
  MANGLE_TARGET_NAMES
  DEFAULT_PDF )

add_dependencies( doc UsersManual_pdf )

install( FILES ${CMAKE_CURRENT_BINARY_DIR}/UsersManual.pdf
  DESTINATION ${DOC_INSTALL_DIR} )

## FIXME: if you want to compile the doc on windaube
#if( WIN32 )
#  exec_program( mkdir ARGS ${CMAKE_CURRENT_BINARY_DIR}/Data )
#  exec_program( cp ARGS ${DIET_DOC_SOURCE_DIR}/../src/examples/Batch/client.c ${CMAKE_CURRENT_BINARY_DIR}/Data/examples_Batch_client.c )
#  exec_program( cp ARGS ${DIET_DOC_SOURCE_DIR}/../src/examples/Batch/batch_server.c ${CMAKE_CURRENT_BINARY_DIR}/Data/examples_Batch_batch_server.c )
#  exec_program( cp ARGS ${DIET_DOC_SOURCE_DIR}/../src/examples/Batch/sequential_server.c ${CMAKE_CURRENT_BINARY_DIR}/Data/examples_Batch_sequential_server.c )
#endif()

=== src/CORBA/CMakeLists.txt ===
#****************************************************************************#
#* DIET cmake local file                                                    *#
#****************************************************************************#

# Generates the CorbaCommon static lib and dietForwarder executable

# Include directories for the library compilation:
#    - OmniORB4 include: try to compile without it! ;)
#    - Binary idl directory: for the generated headers files
#    - Utils dir: for DIET_data_internal.hh
#    - DIET main include dir: for DIET_data.h & DIET_server.h
#    - CORBA dir: DIETLogComponent.hh includes ORBMgr.hh
#    - Juxmem dir: JuxMem is broken. So, don't know why it is necessary.

include_directories(
  ${OMNIORB4_INCLUDE_DIR}
  ${DIET_BINARY_DIR}/src/CORBA/idl    
  ${DIET_SOURCE_DIR}/src/utils
  ${DIET_SOURCE_DIR}/include
  ${DIET_SOURCE_DIR}/src/CORBA
  ${DIET_SOURCE_DIR}/src/utils/config
  ${DIET_SOURCE_DIR}/src/utils/DAGDA)

# Compile CorbaCommon static library
add_library(CorbaCommon STATIC
  ORBMgr.cc
  marshalling.cc
)

# CorbaCommon library depends on CORBA files
add_dependencies(CorbaCommon CORBAFiles)

# Dependency when compiling with Batch support
if (DIET_USE_ALT_BATCH)
  include_directories( ${DIET_SOURCE_DIR}/src/utils/batch )
  add_dependencies( CorbaCommon BatchSystem.hh )
endif (DIET_USE_ALT_BATCH)

# Link CorbaCommon to DIET_CORBA, DIET_Utils and OmniORB
target_link_libraries(CorbaCommon
  DIET_CORBA
)


if (DIET_USE_ALT_BATCH)
  target_link_libraries(CorbaCommon UtilsSeDBatch)
endif (DIET_USE_ALT_BATCH)

# Forwarder include dirs:
# Need all the DIET objects headers.
include_directories(
  ${DIET_SOURCE_DIR}/src/agent
  ${DIET_SOURCE_DIR}/src/client
  ${DIET_SOURCE_DIR}/src/utils/nodes
  ${DIET_SOURCE_DIR}/src/client/workflow
  ${DIET_SOURCE_DIR}/src/agent/workflow
  ${DIET_SOURCE_DIR}/src/utils/workflow
  ${DIET_SOURCE_DIR}/src/SeD
)

set(Forwarder_SOURCES
  SSHTunnel.cc
  Options.cc
#  NetConfig.cc
  forwarders/Agent.cc
  forwarders/Callback.cc
  forwarders/MasterAgent.cc
  forwarders/SeD.cc
#  forwarders/LogComponent.cc
)


set(Forwarder_SOURCES
  ${Forwarder_SOURCES}
  forwarders/Dagda.cc
  )
if (DIET_USE_WORKFLOW)
  set(Forwarder_SOURCES
    ${Forwarder_SOURCES}
    forwarders/CltMan.cc
    forwarders/MaDag.cc
    forwarders/WfLogService.cc
  )
  include_directories(
    ${XERCES_INCLUDE_DIR}
    ${XQILLA_INCLUDE_DIR}
  )
endif (DIET_USE_WORKFLOW)

add_library(LibForwarder STATIC
  ${Forwarder_SOURCES}
)
add_executable(dietForwarder
  ORBMgr.cc
  marshalling.cc
  dietFwdr.cc
  DIETForwarder.cc
  ${Forwarder_SOURCES}
)

# dietForwarder & LibForwarder depend on CORBA files.
add_dependencies(dietForwarder CORBAFiles)
add_dependencies(LibForwarder CORBAFiles)

set(Forwarder_Libs
  ${Forwarder_Libs}
  DIET_Dagda
  )

set(Forwarder_Libs
  DIET_Utils
  ${Forwarder_Libs}
  DIET_CORBA
  CorbaCommon
  UtilsNodes
)

if (DIET_USE_WORKFLOW)
  set(Forwarder_Libs
    ${Forwarder_Libs}
    CltWf
    MaDag
    UtilsWf
    UtilsEvents
    ${XQILLA_LIBRARY}
    ${XERCES_LIBRARY}
  )
endif (DIET_USE_WORKFLOW)
set(Forwarder_Libs
  ${Forwarder_Libs}
  AgentCommon
  DIET_SeD
  DIET_client
  ${OMNIORB4_LIBRARIES}
)

message(STATUS "DIET forwarder libs: ${Forwarder_Libs}")

target_link_libraries(dietForwarder
  ${Forwarder_Libs}
)
if (DIET_USE_USERSCHED)
  target_link_libraries(dietForwarder ${CMAKE_DL_LIBS})
endif (DIET_USE_USERSCHED)

## ------------- New : For scheduler load support. ---------------
# Install the files needed for a scheduler creation.

if (DIET_USE_USERSCHED)
  install( FILES marshalling.hh DESTINATION ${INCLUDE_INSTALL_DIR}/scheduler )
endif (DIET_USE_USERSCHED)
  
install(TARGETS dietForwarder DESTINATION ${BIN_INSTALL_DIR})


if (DIET_USE_LOG)
  include_directories(
    ${LOG_INCLUDE_DIR}
    ${LOG_INCLUDE_DIR}/monitor
    ${LOG_INCLUDE_DIR}/idl
    ${DIET_SOURCE_DIR}/src/utils/log)

  set(Forwarder_Libs
    ${Forwarder_Libs}
    DietLogLibrary)

endif (DIET_USE_LOG)

if (DIET_BUILD_TOOLS)
  add_subdirectory(tools)
endif (DIET_BUILD_TOOLS)

=== src/SeD/CMakeLists.txt ===
#****************************************************************************#
#* DIET cmake local file                                                    *#
#****************************************************************************#

## Sources
set(DIET_SeD_SOURCES
  DIET_server.cc
  SeDImpl.cc
)


if (DIET_USE_ALT_BATCH)  # in that case, put lib UtilsCoRI in lib DIET_SeD
  include_directories(${DIET_SOURCE_DIR}/src/utils/batch)
  set(DIET_SeD_SOURCES
    ${DIET_SeD_SOURCES}
    ${DIET_SOURCE_DIR}/src/utils/batch/Cori_batch.cc
    ${DIET_SOURCE_DIR}/src/utils/nodes/Cori_Data_Easy.cc
    ${DIET_SOURCE_DIR}/src/utils/nodes/Cori_Easy_CPU.cc
    ${DIET_SOURCE_DIR}/src/utils/nodes/Cori_Easy_Disk.cc
    ${DIET_SOURCE_DIR}/src/utils/nodes/Cori_Easy_Memory.cc
    ${DIET_SOURCE_DIR}/src/utils/nodes/Cori_Metric.cc
    ${DIET_SOURCE_DIR}/src/utils/nodes/CORIMgr.cc
  )
endif (DIET_USE_ALT_BATCH)
  
include_directories(${OMNIORB4_INCLUDE_DIR}
  ${DIET_SOURCE_DIR}/src/utils
  ${DIET_SOURCE_DIR}/src/utils/nodes
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${DIET_SOURCE_DIR}/src/agent        # for e.g. ChildID.hh
  ${DIET_SOURCE_DIR}/src/CORBA        # for e.g. marshalling.hh
  ${DIET_SOURCE_DIR}/include          # for DIET_data.h 
  ${DIET_BINARY_DIR}/src/CORBA/idl
  ${DIET_SOURCE_DIR}/src/utils/config
)
  
if (DIET_USE_LOG)
  include_directories(
    ${LOG_INCLUDE_DIR}
    ${DIET_SOURCE_DIR}/src/utils/log)
endif (DIET_USE_LOG)

include_directories(${DIET_SOURCE_DIR}/src/utils/DAGDA)


add_library(DIET_SeD ${DIET_SeD_SOURCES})
SET_TARGET_PROPERTIES (DIET_SeD PROPERTIES VERSION ${DIET_VERSION})

# DIET_Sed shared & static libraries depends on CORBA files.
add_dependencies(DIET_SeD CORBAFiles)


## Dependencies towards other libraries  
# /!\ DIET_Dagda has to be included first (before any other DIET
# library), otherwise it won't work on APPLE.
set(DIET_SeD_Libs
  ${DIET_SeD_Libs}
  DIET_Dagda
  )

# Link with log only if log enabled
if (DIET_USE_LOG)
  set(DIET_SeD_Libs
    ${DIET_SeD_Libs}
    DietLogLibrary)
endif (DIET_USE_LOG)

# common DIET libs
set(DIET_SeD_Libs
  ${DIET_SeD_Libs}
  DIET_CORBA
  CorbaCommon
  UtilsNodes
  DIET_Utils
  ${OMNIORB4_LIBRARIES}
)


# CORI
set(DIET_SeD_Libs
  ${DIET_SeD_Libs}
  UtilsCori
  )

target_link_libraries(DIET_SeD ${DIET_SeD_Libs})
  
if (DIET_USE_ALT_BATCH)
  target_link_libraries(DIET_SeD UtilsSeDBatch)
endif (DIET_USE_ALT_BATCH)

if (NOT BUILD_SHARED_LIBS)
  target_link_libraries(DIET_SeD stdc++)
endif (NOT BUILD_SHARED_LIBS)


# Install DIET_SeD library only, not the static one
install(TARGETS DIET_SeD DESTINATION ${LIB_INSTALL_DIR})

=== src/Testing/CMakeLists.txt ===
#RE Root CMakeLists.txt file
#
# Project: diet-test
# Author: H. Guémar (haikel.guemar@gmail.com)
# Date: Dec. 2010 21

if( BUILD_TESTING )

  # Tests HAVE TO be built without the gcov compilation flag.
  # Thus, we for the build type to Release, as the gcov compilation
  # flags are set for in Debug mode.
  SET(CMAKE_BUILD_TYPE "Release")

  find_package(Boost 1.46.0 COMPONENTS
    unit_test_framework
    filesystem
    system
    thread REQUIRED)
  set(Boost_MULTITHREADED OFF)
  add_definitions(-DBOOST_FILESYSTEM_VERSION=3)

  #find_package( GTest REQUIRED )
  include( tests/DietTestingMacros )

  option( ENABLE_REPORTS 
    "add a test-xml target that allow generating xml reports for analysis tools"
    OFF )

  # omniORB setup
  set( OMNINAMES_LOGDIR ${CMAKE_CURRENT_BINARY_DIR}/log
    CACHE PATH "PATH to the omniNames directory" )
  set( OMNIORB_INSTALL_DIR "" CACHE PATH
    "PATH to the omniORB installation directory" )
  string(RANDOM LENGTH 5 ALPHABET "12345" PORTTMP)
  math(EXPR PORTTMP2 "${PORTTMP} + 1")
  set( LOCAL_TEST_PORT "${PORTTMP}" CACHE STRING "Test port for the omniNames" )
  set( LOCAL_TEST_PORT2 "${PORTTMP2}" CACHE STRING "Test port for the second omniNames" )
  file( MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/log )

  set( SSH_LOCALHOST_USER "$ENV{USER}" CACHE STRING "User allowed to do a \"ssh 127.0.0.1\"" )


  # test setup 
  # for the moment, we only support in-place testing
  set( BIN_DIR ${PROJECT_BINARY_DIR}/bin )
  set( CONFIG_DIR ${PROJECT_BINARY_DIR}/etc )
  set( EXECUTABLE_OUTPUT_PATH ${BIN_DIR} )
  set( WF_XML_DIR ${PROJECT_BINARY_DIR}/test_workflows )
  set( GENERATED_LOG_TESTS_DIR ${PROJECT_BINARY_DIR}/generated_test_logs )
  set( GENERATED_FWD_TESTS_DIR ${PROJECT_BINARY_DIR}/generated_test_forwarders )
  set( GENERATED_LOGFWD_TESTS_DIR ${PROJECT_BINARY_DIR}/generated_test_logs_forwarders )

  set( DIET_CLIENT_LIBRARIES DIET_client DIET_Dagda)
  set( DIET_SERVER_LIBRARIES DIET_SeD DIET_Dagda)
  set( DIET_ADMIN_LIBRARIES DIET_admin)

  diet_test_setup()

  # temporary directories for Dagda
  string(RANDOM LENGTH 32 TMPPATHUUID)
  file( TO_NATIVE_PATH "/tmp/MA_test-${TMPPATHUUID}"     MA_DAGDA_DIR_NATIVE_PATH )
  file( TO_NATIVE_PATH "/tmp/LA_test-${TMPPATHUUID}"     LA_DAGDA_DIR_NATIVE_PATH )
  file( TO_NATIVE_PATH "/tmp/SeD_test-${TMPPATHUUID}"    SED_DAGDA_DIR_NATIVE_PATH )
  file( TO_NATIVE_PATH "/tmp/Client_test-${TMPPATHUUID}" CLIENT_DAGDA_DIR_NATIVE_PATH )

  set( TRANSFER_FILE_TEST1 "" CACHE PATH "File used for transfer tests")
  set( TRANSFER_FILE_TEST2 "" CACHE PATH "File used for transfer tests")

  string(COMPARE EQUAL "${TRANSFER_FILE_TEST1}" "" TRANSFER_FILE_TEST1_EMPTY )
  string(COMPARE EQUAL "${TRANSFER_FILE_TEST2}" "" TRANSFER_FILE_TEST2_EMPTY )
  if ( TRANSFER_FILE_TEST1_EMPTY )
    message( SEND_ERROR "TRANSFER_FILE_TEST1 is not set, it is required when building tests" )
  else  ( TRANSFER_FILE_TEST1_EMPTY )
    file( TO_NATIVE_PATH ${TRANSFER_FILE_TEST1} TRANSFER_FILE_TEST1_NATIVE_PATH )
  endif ( TRANSFER_FILE_TEST1_EMPTY )
  if ( TRANSFER_FILE_TEST2_EMPTY )
    message( SEND_ERROR "TRANSFER_FILE_TEST2 is not set, it is required when building tests" )
  else  ( TRANSFER_FILE_TEST2_EMPTY )
    file( TO_NATIVE_PATH ${TRANSFER_FILE_TEST2} TRANSFER_FILE_TEST2_NATIVE_PATH )
  endif ( TRANSFER_FILE_TEST2_EMPTY )
 

  add_subdirectory(cfgs)
  add_subdirectory(workflows)
  add_subdirectory(src)

endif( BUILD_TESTING )

=== debian/changelog ===
diet (2.8.0-1ubuntu1) wily; urgency=medium

  * From gcc-5 inline will not work on an external function.  We are
    going to force inline to be "static inline" for gcc anyhow so elide
    the erroneous check for inline support.
  * debian/control: switch to fig2pdf as uniconvertor can no longer parse
    these .fig files; requires texlive-font-utils on Build-Depend:.

 -- Andy Whitcroft <apw@ubuntu.com>  Tue, 11 Aug 2015 11:48:35 +0100

diet (2.8.0-1build4) wily; urgency=medium

  * No change rebuild against boost1.58.

 -- Andy Whitcroft <apw@ubuntu.com>  Tue, 11 Aug 2015 10:47:53 +0100

diet (2.8.0-1build3) utopic; urgency=high

  * No change rebuild against boost1.55.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 28 Apr 2014 03:39:49 +0100

diet (2.8.0-1build2) trusty; urgency=low

  * No change rebuild for Boost 1.54 transition.

 -- Dmitrijs Ledkovs <xnox@ubuntu.com>  Mon, 21 Oct 2013 12:05:39 +0100

diet (2.8.0-1build1) saucy; urgency=low

  * No change rebuild for Boost 1.53 transition.

 -- Dmitrijs Ledkovs <dmitrij.ledkov@ubuntu.com>  Fri, 26 Apr 2013 19:18:40 +0100

diet (2.8.0-1) unstable; urgency=low

  * Initial release  (Closes: #628657)

 -- Haïkel Guémar <haikel.guemar@sysfera.com>  Wed, 11 Jan 2012 10:45:12 +0100

=== debian/control ===
Source: diet
Section: science
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders:  Haïkel Guémar <haikel.guemar@sysfera.com>
Build-Depends: debhelper (>= 7.0.50~), cmake, chrpath,
 omniidl, libomniorb4-dev, uuid-dev, liblogservicecomponentbase2-dev,
 liblogservicetoolbase2-dev, libxerces-c-dev, libxqilla-dev, libboost-dev,
 libboost-regex-dev, imagemagick, python-docutils, texlive-base, latex-xcolor,
 transfig, fig2ps, latex2html, texlive-font-utils
Standards-Version: 3.9.2
Homepage: http://graal.ens-lyon.fr/DIET/
Vcs-Git: git://anonscm.debian.org/debian-science/packages/diet.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/diet.git


Package: diet-agent
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: DIET grid middleware - agent
 DIET (Distributed Interactive Engineering Toolbox) is a middleware designed 
 for HPC (High Performance Computing) in heterogeneous and distributed
 environments (workstations, clusters, grids, clouds).
 DIET provides a standard-compliant implementation of OGF (Open Grid Forum) 
 Grid RPC API.
 It works in a hierarchical fashion, clients requests computational 
 resources to a hierarchy of agents which will choose the most adequate 
 computational service (known as SeD or Server Daemon).
 .
 DIET is the core component of SysFera-DS HPC middleware
 (http://www.sysfera.com/SysFera-DS,10).
 .
 This package include agents necessary to run a DIET hierarchy.

Package: libdiet-sed2.8
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: DIET grid middleware - sed runtime
 DIET (Distributed Interactive Engineering Toolbox) is a middleware designed 
 for HPC (High Performance Computing) in heterogeneous and distributed
 environments (workstations, clusters, grids, clouds).
 DIET provides a standard-compliant implementation of OGF (Open Grid Forum) 
 Grid RPC API.
 It works in a hierarchical fashion, clients requests computational 
 resources to a hierarchy of agents which will choose the most adequate 
 computational service (known as SeD or Server Daemon).
 .
 DIET is the core component of SysFera-DS HPC middleware
 (http://www.sysfera.com/SysFera-DS,10).
 .
 This package contains runtime necessary to run DIET server daemons.

Package: libdiet-sed2.8-dev
Section: libdevel
Architecture: any
Depends: libdiet-sed2.8 (= ${binary:Version}),
         libdiet-dagda2.8-dev (= ${binary:Version}),
         ${misc:Depends}
Description: DIET grid middleware - sed development files
 DIET (Distributed Interactive Engineering Toolbox) is a middleware designed 
 for HPC (High Performance Computing) in heterogeneous and distributed
 environments (workstations, clusters, grids, clouds).
 DIET provides a standard-compliant implementation of OGF (Open Grid Forum) 
 Grid RPC API.
 It works in a hierarchical fashion, clients requests computational 
 resources to a hierarchy of agents which will choose the most adequate 
 computational service (known as SeD or Server Daemon).
 .
 DIET is the core component of SysFera-DS HPC middleware
 (http://www.sysfera.com/SysFera-DS,10).
 .
 DIET development libraries and headers to build DIET server daemons.

Package: libdiet-client2.8
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: DIET grid middleware - client runtime
 DIET (Distributed Interactive Engineering Toolbox) is a middleware designed 
 for HPC (High Performance Computing) in heterogeneous and distributed
 environments (workstations, clusters, grids, clouds).
 DIET provides a standard-compliant implementation of OGF (Open Grid Forum) 
 Grid RPC API.
 It works in a hierarchical fashion, clients requests computational 
 resources to a hierarchy of agents which will choose the most adequate 
 computational service (known as SeD or Server Daemon).
 .
 DIET is the core component of SysFera-DS HPC middleware
 (http://www.sysfera.com/SysFera-DS,10).
 .
 This package contains runtime necessary to run DIET clients.

Package: libdiet-client2.8-dev
Section: libdevel
Architecture: any
Depends: libdiet-client2.8 (= ${binary:Version}),
         libdiet-dagda2.8-dev (= ${binary:Version}),
         ${misc:Depends}
Description: DIET grid middleware - client development files
 DIET (Distributed Interactive Engineering Toolbox) is a middleware designed 
 for HPC (High Performance Computing) in heterogeneous and distributed
 environments (workstations, clusters, grids, clouds).
 DIET provides a standard-compliant implementation of OGF (Open Grid Forum) 
 Grid RPC API.
 It works in a hierarchical fashion, clients requests computational 
 resources to a hierarchy of agents which will choose the most adequate 
 computational service (known as SeD or Server Daemon).
 .
 DIET is the core component of SysFera-DS HPC middleware
 (http://www.sysfera.com/SysFera-DS,10).
 .
 DIET development libraries and headers to build DIET clients.

Package: libdiet-dagda2.8
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: DIET grid middleware - dagda runtime
 DIET (Distributed Interactive Engineering Toolbox) is a middleware designed 
 for HPC (High Performance Computing) in heterogeneous and distributed
 environments (workstations, clusters, grids, clouds).
 DIET provides a standard-compliant implementation of OGF (Open Grid Forum) 
 Grid RPC API.
 It works in a hierarchical fashion, clients requests computational 
 resources to a hierarchy of agents which will choose the most adequate 
 computational service (known as SeD or Server Daemon).
 .
 DIET is the core component of SysFera-DS HPC middleware
 (http://www.sysfera.com/SysFera-DS,10).
 .
 This package contains runtime necessary to run DIET elements.

Package: libdiet-dagda2.8-dev
Section: libdevel
Architecture: any
Depends: libdiet-dagda2.8 (= ${binary:Version}),
         ${misc:Depends}         
Description: DIET grid middleware - dagda development files
 DIET (Distributed Interactive Engineering Toolbox) is a middleware designed 
 for HPC (High Performance Computing) in heterogeneous and distributed
 environments (workstations, clusters, grids, clouds).
 DIET provides a standard-compliant implementation of OGF (Open Grid Forum) 
 Grid RPC API.
 It works in a hierarchical fashion, clients requests computational 
 resources to a hierarchy of agents which will choose the most adequate 
 computational service (known as SeD or Server Daemon).
 .
 DIET is the core component of SysFera-DS HPC middleware
 (http://www.sysfera.com/SysFera-DS,10).
 .
 DIET development libraries and headers to build DIET based applications.

Package: libdiet-admin2.8
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: DIET grid middleware - admin runtime
 DIET (Distributed Interactive Engineering Toolbox) is a middleware designed 
 for HPC (High Performance Computing) in heterogeneous and distributed
 environments (workstations, clusters, grids, clouds).
 DIET provides a standard-compliant implementation of OGF (Open Grid Forum) 
 Grid RPC API.
 It works in a hierarchical fashion, clients requests computational 
 resources to a hierarchy of agents which will choose the most adequate 
 computational service (known as SeD or Server Daemon).
 .
 DIET is the core component of SysFera-DS HPC middleware
 (http://www.sysfera.com/SysFera-DS,10).
 .
 This package contains runtime necessary to run DIET applications
 using admin API.

Package: libdiet-admin2.8-dev
Section: libdevel
Architecture: any
Depends: libdiet-admin2.8 (= ${binary:Version}),
         libdiet-dagda2.8-dev (= ${binary:Version}),
         ${misc:Depends}
Description: DIET grid middleware - admin development files
 DIET (Distributed Interactive Engineering Toolbox) is a middleware designed 
 for HPC (High Performance Computing) in heterogeneous and distributed
 environments (workstations, clusters, grids, clouds).
 DIET provides a standard-compliant implementation of OGF (Open Grid Forum) 
 Grid RPC API.
 It works in a hierarchical fashion, clients requests computational 
 resources to a hierarchy of agents which will choose the most adequate 
 computational service (known as SeD or Server Daemon).
 .
 DIET is the core component of SysFera-DS HPC middleware
 (http://www.sysfera.com/SysFera-DS,10).
 .
 DIET development libraries and headers to build DIET applications
 using admin API.

Package: diet-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: DIET grid middleware - developer documentation
 DIET (Distributed Interactive Engineering Toolbox) is a middleware designed 
 for HPC (High Performance Computing) in heterogeneous and distributed
 environments (workstations, clusters, grids, clouds).
 DIET provides a standard-compliant implementation of OGF (Open Grid Forum) 
 Grid RPC API.
 It works in a hierarchical fashion, clients requests computational 
 resources to a hierarchy of agents which will choose the most adequate 
 computational service (known as SeD or Server Daemon).
 .
 DIET is the core component of SysFera-DS HPC middleware
 (http://www.sysfera.com/SysFera-DS,10).
 .
 DIET documentation contains user manual and user FAQ in PDF forms.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS


%:
	dh $@ 

override_dh_auto_configure :
	dh_auto_configure -- \
-DDIET_BUILD_EXAMPLES=OFF \
-DDIET_USE_ALT_BATCH=ON \
-DDIET_USE_CCS=OFF \
-DDIET_USE_CLOUD=OFF \
-DDIET_USE_USERSCHED=ON \
-DDIET_USE_WORKFLOW=ON \
-DDIET_WITH_MULTI_MA=ON \
-DDIET_WITH_STATISTICS=ON \
-DDIET_USE_LOG=ON \
-DDIET_BUILD_DOC=ON \
-DDOC_INSTALL_DIR=/usr/share/doc/diet-doc \

override_dh_auto_install :
	dh_auto_install --fail-missing
	chrpath --delete $(CURDIR)/debian/tmp/usr/bin/dietAgent
	chrpath --delete $(CURDIR)/debian/tmp/usr/bin/dietForwarder
	chrpath --delete $(CURDIR)/debian/tmp/usr/lib/libDIET_*.so.*

=== debian/watch ===
version=3
# login: diet
# pass: s6EThEs5@
http://graal.ens-lyon.fr/DIET/download.html .*/diet-(.*).tar.gz
